#!/usr/bin/perl

while($FILE = shift) {
    open(FILE, $FILE);
    $nmv=0;
    $cno=0;
    undef(@model);
    undef(%modelh);
    while(<FILE>) {
	chomp;
	if(m/^c ([-]??[0-9]+)$/) {
	    $model[$nmv++]=$1;
	    $modelh{$1}=1;
	}
	if(m/^p cnf ([0-9]+) ([0-9]+)$/) {
	    $nv=$1;
	    $nc=$2;
	    if($#model+1 != $nv) {
		die "$FILE: incorrect number of variables in model\n";
	    }
	}
	if(m/^([0-9\-\ ]+) 0$/) {
	    $cno++;
	    @literals=split / +/,$1;
	    $sat=0;
	    for($i=0;$i<=$#literals;$i++) {
		if($modelh{$literals[$i]}==1) {
		    $sat=1;
		    break;
		}
	    }
	    if(!$sat) {
		die "$FILE: clause ",$cno," unsatisfied by model\n";
	    }
	}
    }
    print "$FILE: ok\n";
}
